macroScript RHistoryToggle category:"Bobo_s Tools" buttontext:"RHistory"
(

--------------------------------------------
--RealRenderHistory 
--version 0.0.1 (Beta)
--Last Edited: 09/11/2002 - God Bless America!
--Copyright (c) 2002 by Borislav Petrov
--bobo@email.archlab.tuwien.ac.at
--http://www.scriptspot.com/bobo/darkmoon/rrh
--------------------------------------------

global RRH_StoreLastRenderData 
persistent global RRH_RenderHistoryEnabled
on isChecked return RRH_RenderHistoryEnabled

on execute do
(
	if RRH_RenderHistoryEnabled == undefined then 
		RRH_RenderHistoryEnabled = true
	else	
		RRH_RenderHistoryEnabled = not RRH_RenderHistoryEnabled
		
	if RRH_RenderHistoryEnabled then
	(
		--Make sure there is a RenderHistory directory to store images into...
		makedir ((GetDir #preview)+"/renderHistory")
		
		fn RRH_StoreLastRenderData =
		(
			local frame_info = 
			local last_image = GetLastRenderedImage()
			local check_for_files = getFiles ((GetDir #preview)+"/renderHistory/RRH_"+(getFileNameFile maxFileName)+"*.rpf")
			local file_exist = true
			local increment = 1
			while file_exist do
			(
				local out_file_name = (GetDir #preview)+"/renderHistory/RRH_"+(getFileNameFile maxFileName)+"_"+(check_for_files.count+increment) as string + ".rpf"
				if (getFiles out_file_name).count == 0 then 
					file_exist = false
				else
					increment += 1
			)

			local scene_info_path = out_file_name+".ini"
			scene_info_file = createFile scene_info_path

			setIniSetting scene_info_path "General" "SceneName" (getFileNameFile maxFileName)
			setIniSetting scene_info_path "General" "RenderDate" localtime
			setIniSetting scene_info_path "General" "ImageWidth" (last_image.width  as string)
			setIniSetting scene_info_path "General" "ImageHeight" (last_image.height as string)
			setIniSetting scene_info_path "General" "CacheFile" out_file_name
			
			if getUseDraftRenderer() then 
				current_renderer = "Draft" 
			else 
				current_renderer = "Production"
			setIniSetting scene_info_path "Renderer" "Renderer" (classof (renderers.current) as string)
			setIniSetting scene_info_path "Renderer" "RendererSetup" current_renderer
			setIniSetting scene_info_path "Renderer" "OutputPath" rendOutputFilename
			setIniSetting scene_info_path "Renderer" "RenderWidth" (renderWidth as string)
			setIniSetting scene_info_path "Renderer" "RenderHeight" (renderHeight  as string)
			setIniSetting scene_info_path "Renderer" "ImageAspect" (getRendImageAspect() as string)
			setIniSetting scene_info_path "Renderer" "PixelAspect" (renderPixelAspect as string)
			setIniSetting scene_info_path "Renderer" "ApertureWidth" (getRendApertureWidth() as string)

			setIniSetting scene_info_path "Renderer" "ColorCheck" (rendColorCheck as string)
			setIniSetting scene_info_path "Renderer" "SuperBlack" (rendSuperBlack as string)
			setIniSetting scene_info_path "Renderer" "SuperBlackThreshold" (rendSuperBlackThresh as string)
			setIniSetting scene_info_path "Renderer" "RenderHidden" (rendHidden as string) 
			setIniSetting scene_info_path "Renderer" "Force2Sided" (rendForce2Side as string)

			setIniSetting scene_info_path "Renderer" "RenderAtmosphere" (rendAtmosphere  as string)
			setIniSetting scene_info_path "Renderer" "RenderDisplacements" (renderDisplacements  as string)
			setIniSetting scene_info_path "Renderer" "RenderEffects" (renderEffects  as string)
			setIniSetting scene_info_path "Renderer" "DitherTrueColor" (rendDitherTrue  as string)
			setIniSetting scene_info_path "Renderer" "Dither256Color" (rendDither256  as string)
			setIniSetting scene_info_path "Renderer" "MultiThreaded" (rendMultiThread  as string)


			setIniSetting scene_info_path "AntiAliasing" "Filter" (classof (scanlineRender.antiAliasFilter) as string)
			setIniSetting scene_info_path "AntiAliasing" "FilterSize" (scanlineRender.antiAliasFilterSize as string)
			setIniSetting scene_info_path "AntiAliasing" "PixelSampler" (scanlineRender.enablePixelSampler as string)
			
			
			setIniSetting scene_info_path "SceneInfo" "TotalObjectsCount" (objects.count as string)
			setIniSetting scene_info_path "SceneInfo" "GeometryObjectsCount" (geometry.count as string)
			setIniSetting scene_info_path "SceneInfo" "CameraObjectsCount" (cameras.count as string)
			setIniSetting scene_info_path "SceneInfo" "LightsObjectsCount" (lights.count as string)
		
			last_image.filename = out_file_name 
			save last_image
			close last_image
			last_image = undefined
			try(rrh_rollout.update_history_display 100.0)catch()
		)
		callbacks.removeScripts #postRender id:#rrhistory
		callbacks.addScript #postRender "RRH_StoreLastRenderData()" id:#rrhistory
	)
	else	
	(
		callbacks.removeScripts #postRender id:#rrhistory
	)--end if	
)--end on execute

)--end script


macroScript RHistoryBrowse category:"Bobo_s Tools" buttontext:"See RHistory"
(
global rrh_rollout 
local preview_image = bitmap 320 240
local vfb_image = bitmap 320 240
local image_index = 1
local get_image_files = #()
local LeftMouseDown = false
rollout rrh_rollout "RealRenderHistory"
(
	bitmap rrh_preview width:320 height:240 bitmap:preview_image pos:[1,0]
	progressbar rrh_slider align:#center value:0 width:320 height:20 pos:[1,240] 
	checkbutton rrh_display_vfb "Show VFB" height:20 width:70 checked:false pos:[2,260] highlightcolor:(color 200 255 200) tooltip:"Show Images in VFB"
	button rrh_load_ramplayer "RAMplayer" height:20 width:70 pos:[2,280] tooltip:"Load Images in RAMplayer"

	checkbutton rrh_scene_only "Scene Only" height:20 width:70 pos:[72,260] highlightcolor:(color 200 255 200) checked:true tooltip:"Show Current Scene Images only / Show All Images"
	checkbutton rrh_drag_image "Image Drag" height:20 width:70 pos:[72,280] highlightcolor:(color 200 200 255) tooltip:"Click and Drag Mouse over Image to Scroll History"
	
	button rrh_delete_image "Delete" height:20 width:60 pos:[142,260] tooltip:"Delete Current Image"
	button rrh_delete_all   "Delete All" height:20 width:60 pos:[142,280] tooltip:"Delete All Images"

	button rrh_image_info "Settings" height:20 width:60 pos:[202,260] enabled:false
	button rrh_scene_info "Report" height:20 width:60 pos:[202,280] tooltip:"Generate Image Report"
	
	spinner rrh_current_frame range:[1,1,1] type:#integer pos:[262,262] fieldwidth:40
	
	fn build_image_report scene_info_path image_info_path =
	(
		image_info_file = createFile image_info_path
		format "==========================================\n" to:image_info_file
		format "RENDER HISTORY - IMAGE REPORT\n" to:image_info_file
		format "==========================================\n" to:image_info_file
		
		str = getIniSetting scene_info_path "General" "SceneName" 
		format "Scene Name:  \t\t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "General" "RenderDate" 
		format "Render Date: \t\t%\n" str to:image_info_file
		str1 = getIniSetting scene_info_path "General" "ImageWidth" 		
		str2 = getIniSetting scene_info_path "General" "ImageHeight" 
		format "Image Size: \t\t% x %\n" str1 str2 to:image_info_file
		str = getIniSetting scene_info_path "General" "CacheFile" 		
		format "RRH Cache Name: \t%\n" str to:image_info_file
		format "==========================================\n" to:image_info_file
		format "RENDERER SETTINGS:\n" to:image_info_file

		str = getIniSetting scene_info_path "Renderer" "Renderer" 
		format "Current Renderer: \t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "RendererSetup" 
		format "Renderer Setup: \t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "OutputPath" 
		format "Output Path: %\n" str to:image_info_file		
		
		str1 = getIniSetting scene_info_path "Renderer" "RenderWidth" 
		str2 = getIniSetting scene_info_path "Renderer" "RenderHeight" 
		format "Render Size: \t\t% x %\n" str1 str2 to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "ImageAspect" 
		format "Image Aspect: \t\t%\n" str  to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "PixelAspect" 
		format "Pixel Aspect: \t\t%\n" str  to:image_info_file
		
		str = getIniSetting scene_info_path "Renderer" "ApertureWidth" 
		format "Aperture Width: \t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "ColorCheck" 
		format "Color Check: \t\t%\n" str  to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "SuperBlack" 
		format "Super Black: \t\t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "SuperBlackThreshold" 
		format "S.Black Threshold: \t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "RenderHidden" 
		format "Render Hidden: \t\t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "Force2Sided" 
		format "Force 2 Sided: \t\t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "RenderAtmosphere" 
		format "Atmosphere: \t\t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "RenderDisplacements" 
		format "Displacement: \t\t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "RenderEffects" 
		format "RenderEffects: \t\t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "DitherTrueColor" 
		format "Dither TrueColor: \t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "Dither256Color" 
		format "Dither 8-bit: \t\t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "Renderer" "MultiThreaded" 
		format "Multi-Threaded: \t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "AntiAliasing" "Filter" 
		format "AA-Filter:      \t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "AntiAliasing" "FilterSize" 
		format "AA-Filter Size: \t%\n" str to:image_info_file
		str = getIniSetting scene_info_path "AntiAliasing" "PixelSampler" 
		format "Pixel Sampler:  \t%\n" str to:image_info_file
			
		format "==========================================\n" to:image_info_file
		format "SCENE INFO:\n" to:image_info_file
		str = getIniSetting scene_info_path "SceneInfo" "TotalObjectsCount" 
		format "Total Objects Count:    %\n" str to:image_info_file
		str = getIniSetting scene_info_path "SceneInfo" "GeometryObjectsCount" 
		format "Geometry Objects Count: %\n" str to:image_info_file
		str = getIniSetting scene_info_path "SceneInfo" "CameraObjectsCount" 
		format "Cameras Count:          %\n" str to:image_info_file
		str = getIniSetting scene_info_path "SceneInfo" "LightsObjectsCount" 
		format "Lights Count:           %\n" str to:image_info_file
		format "==========================================\n" to:image_info_file
			
		close image_info_file
		edit image_info_path
	)
	
	fn build_ramplayer_ifl =
	(
		if rrh_scene_only.checked then file_name = (getFileNameFile maxFileName) else file_name = ""
		local get_image_files = getFiles ((GetDir #preview)+"/renderHistory/RRH_"+file_name+"*.rpf")
		local ifl_path_1 = ((GetDir #preview)+"/renderHistory/RRH_List_1.ifl")
		local ifl_path_2 = ((GetDir #preview)+"/renderHistory/RRH_List_2.ifl")
		local temp_ifl_1 = createfile ifl_path_1
		local temp_ifl_2 = createfile ifl_path_2
		format "%\n" (fileNameFromPath get_image_files[1]) to:temp_ifl_1
		for i in get_image_files do
		(
			format "%\n" (fileNameFromPath i) to:temp_ifl_1
			format "%\n" (fileNameFromPath i) to:temp_ifl_2
		)
		close temp_ifl_1
		close temp_ifl_2
		RAMplayer ifl_path_1 ifl_path_2
	)
	
	fn update_history_display val =
	(
		if rrh_scene_only.checked then file_name = (getFileNameFile maxFileName) else file_name = ""
		local get_image_files = getFiles ((GetDir #preview)+"/renderHistory/RRH_"+file_name+"*.rpf")
		local image_index = (val*get_image_files.count/100.0 as integer)+1
		if image_index > get_image_files.count then  image_index = get_image_files.count
		if image_index > 0 then
		(
			current_image = openbitmap get_image_files[image_index]
			copy current_image preview_image 
			rrh_preview.bitmap = preview_image
			
			if rrh_display_vfb.checked then 
			(
				if vfb_image.height != current_image.height or vfb_image.width != current_image.width then
				(
					close vfb_image
					vfb_image = bitmap current_image.width current_image.height
				)
				copy current_image vfb_image
				display vfb_image 
			)
			close current_image 	
		)	
		else
		(
			current_image = bitmap 32 24
			copy current_image preview_image 
			rrh_preview.bitmap = preview_image
			copy current_image vfb_image
			image_index= 1
		)
		rrh_current_frame.range = [1,get_image_files.count, image_index]
		rrh_slider.value = 100.0 * image_index / get_image_files.count 
	)
	
	on rrh_slider clicked val do update_history_display val 
	
	on rrh_current_frame changed val do 
	(
		new_val = (100.0*(val-1)/rrh_current_frame.range.y)
		update_history_display new_val 
	)	

	on rrh_display_vfb changed state do 
	(
		if state == false then 
			undisplay vfb_image
		else
			update_history_display rrh_slider.value
	)
	
	on rrh_load_ramplayer pressed do build_ramplayer_ifl()
	
	on rrh_delete_all pressed do
	(	
		if rrh_scene_only.checked then 
		(
			file_name = (getFileNameFile maxFileName)
			q = queryBox "Delete Current Scene Images from History?" title:"RRH"
		)	
		else 
		(
			file_name = ""
			q = queryBox "Delete ALL Images from History?" title:"RRH"
		)	

		if q then
		(
			local get_image_files = getFiles ((GetDir #preview)+"/renderHistory/RRH_"+file_name+"*.rpf")
			for i in get_image_files do 
			(
				deleteFile i
				deleteFile (i+".ini")
				deleteFile (i+".txt")
			)	
			update_history_display rrh_slider.value
		)	
	)	
	on rrh_delete_image pressed do
	(	
		if rrh_scene_only.checked then 
			file_name = (getFileNameFile maxFileName)
		else 
			file_name = ""

		q = queryBox "Delete Current Image from History?" title:"RRH"
		if q then
		(
			local get_image_files = getFiles ((GetDir #preview)+"/renderHistory/RRH_"+file_name+"*.rpf")
			deleteFile get_image_files[rrh_current_frame.value]
			deleteFile (get_image_files[rrh_current_frame.value]+".ini")
			deleteFile (get_image_files[rrh_current_frame.value]+".txt")
			update_history_display rrh_slider.value
		)	
	)	

	on rrh_scene_info pressed do
	(
		if rrh_scene_only.checked then 
			file_name = (getFileNameFile maxFileName)
		else 
			file_name = ""

		local get_image_files = getFiles ((GetDir #preview)+"/renderHistory/RRH_"+file_name+"*.rpf")
		build_image_report (get_image_files[rrh_current_frame.value]+".ini") (get_image_files[rrh_current_frame.value]+".txt") 
	)
	
	on rrh_scene_only changed state do update_history_display rrh_slider.value
	on rrh_rollout close do undisplay vfb_image
	on rrh_rollout lButtonDown pos do LeftMouseDown = True
	on rrh_rollout lButtonUp pos do	LeftMouseDown = False
	
	on rrh_rollout mouseMove pos do
	(
		if LeftMouseDown and rrh_drag_image.checked then 
		(
			val = 100.0*((pos.x/320.0))
			if val < 0 then val = 0
			update_history_display val
		)	
	)
	
)
freescenebitmaps()
gc light:true
destroyDialog rrh_rollout
createDialog rrh_rollout 320 300 100 100
rrh_rollout.update_history_display 100.0
)
